#include	"TcpSocket.h"

#include	"krb5.h"
#include	"com_err.h"

#define	TICKET_LIFE	(10 * 60l * 60l)
#define	EXPIRE_TIME	(     20l * 60l)

/*	Kerberos 5 Server Context.	*/
typedef	struct	Krb5ServerContext_st
{
	/*	Kerberos 5 information.	*/
	krb5_context		context;
	krb5_ccache			defaultCache;
	krb5_keytab			keyTable;
	krb5_principal		serverPrincipal;
} Krb5ServerContext_t;

/*#############################################################################
#	Kerberos 5 Server Data Attributes.
#############################################################################*/

#define	Krb5Server_DAS								\
	/*	Super class data attributes.	*/			\
	TcpSocket_DAS									\
													\
	/*	Server Context.	*/							\
	Krb5ServerContext_t	serverContext;				\
	krb5_auth_context	authorizationContext;		\
													\
	/*	Authorization flag.	*/						\
	int					krb5AuthFlag;

/*	Kerberos 5 Server Data Attributes.	*/
typedef	struct	Krb5TcpServerDAs_st
{
	Krb5Server_DAS
} Krb5TcpServerDAs_t;

/*#############################################################################
#	Kerberos 5 TCP Socket Data Attributes.
#############################################################################*/

#define	Krb5TcpSocket_DAS								\
	/*	Super class data attributes.	*/			\
	TcpSocket_DAS									\
													\
	/*	Server Context.	*/							\
	Krb5ServerContext_t	serverContext;				\
	krb5_auth_context	authorizationContext;		\
	krb5_principal		clientPrincipal;			\
													\
	/*	Authorization flag.	*/						\
	int					krb5AuthFlag;

/*	Kerberos 5 Server Data Attributes.	*/
typedef	struct	Krb5TcpSocketDAs_st
{
	Krb5TcpSocket_DAS
} Krb5TcpSocketDAs_t;

/*#############################################################################
#	Kerberos 5 Client Data Attributes.
#############################################################################*/

#define	Krb5Client_DAS								\
	/*	Super class data attributes.	*/			\
	Krb5TcpSocket_DAS

/*	Kerberos 5 Server Data Attributes.	*/
typedef	struct	Krb5TcpClientDAs_st
{
	Krb5Client_DAS
} Krb5TcpClientDAs_t;

/*#############################################################################
#	Kerberos 5 Service Proxy Data Attributes.
#############################################################################*/

#define	Krb5Proxy_DAS								\
	/*	Super class data attributes.	*/			\
	Krb5TcpSocket_DAS								\
													\
	/*	Server authentication data attributes.	*/	\
	krb5_principal		tgtPrincipal;				\
	krb5_creds			credentials;				\
	char				*tgtServiceName;			\
	char				*fullClientName;			\
	char				*clientName;				\
	char				*realm;

/*	Kerberos 5 Server Data Attributes.	*/
typedef	struct	Krb5TcpProxyDAs_st
{
	Krb5Proxy_DAS
} Krb5TcpProxyDAs_t;

/*#############################################################################
#	Kerberos 5 Connection Data Attributes.
#############################################################################*/

#define	Krb5Connection_DAS							\
	/*	Super class data attributes.	*/			\
	Krb5TcpSocket_DAS

/*	Kerberos 5 Server Data Attributes.	*/
typedef	struct	Krb5TcpConnectionDAs_st
{
	Krb5Connection_DAS
} Krb5TcpConnectionDAs_t;
