#!/usr/bin/ruby1.8
#******************************************************************************
# Module:
#	StorageConsumer
#
# Description:
#	StorageConsumer frame work.  Just to send some basic messages to a
#	StorageProducer frame.
#
# Author:
#	John W. M. Stevens
#******************************************************************************

require 'ActiveObject'
require 'Receptionist'
require	'Krb5Proxy'

class StorageConsumer < ActiveObject

	def doIt
		#	Create proxy for test object.
		@proxy = ServiceProxy.new(
			self.class.name,
			9002,
			'morningstar.nowhere.lie',
			'StorageProducer')

		#	Send increment message to proxy 4 times.
		4.times {
			@proxy.increment
		}

		#	Tell producer we are done incrementing.
		@proxy.show(
			"Total",
			9001,
			'morningstar.nowhere.lie',
			self.class.name )

		#	Discard proxy.
		@proxy.close
	end

	def showTotal(
		value )

		#	Show total sent from producer.
		$stdout.print value
	end
end

#	Start storage consumer.
ao =
	Receptionist.new(
		9001,
		'morningstar.nowhere.lie',
		StorageConsumer )
ao.processMessagesUntilStopped
