#!/usr/bin/ruby1.8
#******************************************************************************
# Module:
#	StorageProducer
#
# Description:
#	StorageProducer frame work.
#
# Author:
#	John W. M. Stevens
#******************************************************************************

require 'ActiveObject'
require 'Receptionist'
require 'Krb5Proxy'

class StorageProducer < ActiveObject

	def initialize(
		readChannel )

		super
		@count = 0
	end

	def increment
		@count = @count + 1
	end

	def show(
		prefix,
		port,
		interface,
		service )

		#	Create new proxy.
		proxy =
			ServiceProxy.new(
				self.class.name,
				port,
				interface,
				service )

		#	Create value string and send it.
		value = "#{prefix} --> Count: #{@count}\n"
		proxy.showTotal(
			value )

		#	Discard proxy.
		proxy.close
	end
end

ao =
	Receptionist.new(
		9002,
		'morningstar.nowhere.lie',
		StorageProducer )
ao.processMessagesUntilStopped
