/******************************************************************************
* Module:
*	TcpSocket Header File
*
* Description:
*	Define TcpSocket data attributes.
*
* Author:
*	John W. M. Stevens
******************************************************************************/

#include	<netdb.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<netinet/tcp.h>

/*=============================================================================
||	Socket Data Attributes.
=============================================================================*/

#define	TcpSocket_DAS							\
	/*	Service side data.	*/					\
	char				*serviceName;			\
	char				*serviceInterface;		\
	int					servicePort;			\
	struct sockaddr_in	serviceAddress;			\
												\
	/*	Client side data.	*/					\
	char				*clientInterface;		\
	int					clientPort;				\
	struct sockaddr_in	clientAddress;			\
												\
	/*	Socket number and accept klass.	*/		\
	int					sock;					\
	VALUE				klass;

/*	Socket information.	*/
typedef	struct	TcpSocketDas_st
{
	TcpSocket_DAS
} TcpSocketDAs_t;

/*	Define class.	*/
extern	VALUE	cTcpSocket;
